<?php
//error_messages[E_ALL]; 
// SIGN UP REQUIREMENTS
// email must unique for every member
// password must be entered twice correctly - passwords don't have to be unique
require_once ("includes/validation/validation_functions.php");
require_once ("includes/files/write_to_a_flat_file4.php");
require_once ("includes/sql/write_signup_db.php");
require_once ("includes/sql/email_exists_check_db.php");

if (@$_POST['submitted']) {
	$first_name = @$_POST['first_name'];
  $last_name = @$_POST['last_name'];
  $email = @$_POST['email'];
  $password1 = @$_POST['password1'];
	$password2 = @$_POST['password2'];
	
	$error_msg=array(); /* intialize error array for form errors*/

// the validation functions are in a separate include file - see above

$valid = verifyAlphaNum ($first_name); /* test for non-valid  data */
if (!$valid){ 
$error_msg[]="First Name must be letters and numbers, spaces, dashes and ' only.";
}

$valid = verifyAlphaNum ($last_name); /* test for non-valid  data */
if (!$valid){ 
$error_msg[]="Last Name must be letters and numbers, spaces, dashes and ' only.";
}

$valid = verifyEmail ($email); /* test for non-valid  data */
if (!$valid){ 
$error_msg[]="Email must be a valid format (e.g. john@yahoo.com).";
} else { // the email format is good so...
	// check if email is already in db - if so, function returns 1 - see error output in form below.
	$returnedID = checkEmail($email);  // returns the user id, or 0 if the email does not already exist in db
	////if (!$returnedID) {print "nothing returned";}
}

if (((strlen($password1)) < 4) or ((strlen($password1))) > 10){
$error_msg[]="Password must be between 4 and 10 characters in length.";
} 
 
if ($password1 !== $password2) {
$error_msg[]="Both password fields must match. Please try again.";
}
	
$valid = verifyPassword ($password1); /* test for non-valid  data */
if (!$valid){ 
$error_msg[]="Password can only contain letters and numbers.";
}

/* if no errors, and we are here b/c the form was submitted rather than the page first loading */
 	if  (!$returnedID &&!$error_msg && $_POST['submitted']) {  // everything is good - add record to db
   
		//write to database
		writeMemberSignup ($first_name, $last_name, $email, $password1);
		setcookie('loggedIn'); // give the user a cookie
		/* redirect to a new page - we are done on this page */
		header ('Location: members_page.php');
	 /* stop the script right here */
   	exit();
	}    
}       /*end of if post submitted */
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Codin' - Authentication</title>
<link type="text/css" media="screen" href="../css/codin_styles.css" />
<style type="text/css">
body {font-family:arial, sans serif}
label {font-weight:bold; font-size:.8em;}
</style>
</head>
<body>
  <div id="content">
  <form action="<?php $_SERVER['PHP_SELF'] ?>" method="POST">
  <h3>Sign up</h3>
	<p>Members can download code samples and access the Codin' links.</p>
	<?php  // present errors to the user
	//if the email exists in the db, the other errors (or not) are irrelevant
	if ($returnedID) {
	echo '<p class="msg">A record with this email address already exists - you are already a member!</p>';
	echo "<ul>\n"; /* open a list  - the \n formats the code view*/  
	echo '<li><a href="sign_in.php">Log in on home page</a></li>';	
	echo '<li><a href="email_password.php">Email me my password</a></li>';	
	echo "</ul>";    /* close the list */
	} else { // the email does not exist, so write out any errors
	
		if ($error_msg) {
		  echo "<h4>Errors!</h4>";
			echo "<ul>\n"; // open a list  - the \n formats the code view
	  	foreach ($error_msg as $err) { // write out the error array as list items 
	  	echo "<li>".$err."</li>\n";
	  	} // end foreach
			echo "</ul>";    // close the list 
		} //end if errormsg
	} //end if $emailExists
	?>
	<label for="first_name">First Name<span> required</span></label><br />
      <input name="first_name" type="text" size="20" id="first_name" value="<?php echo ($first_name) ?>" /><br />
	    <label for="last_name">Last Name<span> required</span></label><br />
      <input name="last_name" type="text" size="20" id="last_name" value="<?php echo ($last_name) ?>" /><br />
      <label for="email">Email<span> required</span></label><br />
      <input name= "email" type="text" size="20" id="email" value="<?php echo ($email) ?>" /><br />
	    <label for="password1">Password<span> required - 4 to 8 letters/numbers</span></label><br />
      <input name= "password1" type="password" size="10" id="password1" /><br />
			<label for="password2">Type password again<span> required</span></label><br />
      <input name= "password2" type="password" size="10" id="password2" /><br />
      <input type="submit" value="Go" name="submitted"/>
    </form>
  </div>
</body>
</html>

